% triangulation example
u =[ -0.3487   -0.2224   -0.1640
    	0.5565    0.3505    0.2561]; % noisy observations

P{1}=[1     0     0     0
     	0     1     0     0
     	0	    0     1     2];

P{2}=[ 1     0     0     0
     	 0     1     0     0
       0     0     1     3];

P{3}=[ 1     0     0     0
			 0     1     0     0
			 0     0     1     4];

U0=[-0.6084
		 0.9552
		-0.2676]; % ground truth without any noise
		
epsilon = 0.95;
delta = 5;
maxiter = 300;


addpath 'l2l2'
addpath 'l2l1'
addpath 'l1l1'

Ul2l2 =  l2l2_triangulation(u,P,epsilon,delta,maxiter); 
Ul1l1 =  l2l1_triangulation(u,P,epsilon,delta,maxiter);
Ul2l1 =  l1l1_triangulation(u,P,epsilon,delta,maxiter);


fprintf('ground truth\n')
U0
fprintf('(L2,L2) Estimate \n')
Ul2l2

fprintf('(L2,L1) Estimate \n')
Ul2l1

fprintf('(L1,L1) Estimate \n')
Ul1l1