function [Hnew,xbnd] =  l1l1_resection_initial_rectangle3(opts,flag);

nvars = opts.dim1*opts.dim2;
nlinear = 2*(opts.dim1-1)*opts.n;

A = zeros(nlinear,nvars);
c = zeros(nlinear,1);
Aeq = zeros(1,nvars);
beq = zeros(1,1);
xbnd=-1;

X = [opts.StructureArray(1,:) 1];

Aeq(1,opts.dim2*(opts.dim1-1)+1:opts.dim1*opts.dim2)=X;
beq(1) = 1;

srow=0;
for k = 1:opts.dim1-1;
    c(srow+2*k-1)=(opts.delta - opts.PointsArray(1,k));
    A(srow+2*k-1,opts.dim2*(k-1)+1:opts.dim2*k)=-X;

    c(srow+2*k)=(opts.delta + opts.PointsArray(1,k));
    A(srow+2*k,opts.dim2*(k-1)+1:opts.dim2*k)=X;
end

for j = 2:opts.n;
    srow = (j-1)*2*(opts.dim1-1);
    X = [opts.StructureArray(j,:) 1];
    for k = 1:opts.dim1-1;
        A(srow+2*k-1,opts.dim2*(opts.dim1-1)+1:opts.dim1*opts.dim2)=(-opts.delta + opts.PointsArray(j,k))*X;
        A(srow+2*k-1,opts.dim2*(k-1)+1:opts.dim2*k)=-X;

        A(srow+2*k,opts.dim2*(opts.dim1-1)+1:opts.dim1*opts.dim2)=(-opts.delta - opts.PointsArray(j,k))*X;
        A(srow+2*k,opts.dim2*(k-1)+1:opts.dim2*k)=X;
    end
end

A=sparse(A);
c=sparse(c);
Aeq =sparse(Aeq);
beq =sparse(beq);

if nargin > 1;
    i=2; % change this to the first branching dimension
    b = [zeros(1,(opts.dim1-1)*opts.dim2) opts.StructureArray(i,:) 1];
    b = sparse(b);
    [x1,fval1,exitflag1]=linprog(b,A,c,Aeq,beq,[],[],[],opts.lpoptions);
    if (exitflag1==1);
        Hnew = 1;
    else
        Hnew = 0;
    end
    return;
end


Hnew = opts.ybounds;

fprintf('[');
for i = 2:opts.n;
   
    if (opts.branch_array(i));
        fprintf('.');
        b = [zeros(1,(opts.dim1-1)*opts.dim2) opts.StructureArray(i,:) 1];
	b = sparse(b);
        %minimize
        [x1,fval1,exitflag1,output1,lambda1]=linprog(b,A,c,Aeq,beq,[],[],[],opts.lpoptions);
        [x2,fval2,exitflag2,output2,lambda2]=linprog(-b,A,c,Aeq,beq,[],[],[],opts.lpoptions);
        fval2=-fval2;
        
        
	switch exitflag1;
	  
	 case 1;
	  fprintf('.');
	  fval1 = max(1e-10,fval1);
	 case -3;
	  fprintf('\');
	  fval1 = opts.ybounds(i,1);
	 otherwise
	  fval1 = -1;
	end
	
	switch exitflag2;
		  
	 case 1;
	  fprintf('.');
	  if (fval1 > opts.ybounds(i,2))
	    fval2 = fval1+opts.ybounds(i,2);
	  else
	    fval2 = min(max(1e-10,fval2),opts.ybounds(i,2));
	  end
	   
	  fval2 = max(1e-10,fval2);
	 case -3;
	  fprintf('/');
	  fval2 = opts.ybounds(i,2);
	 otherwise
	  fval2 = -1;
	end
	
	
	if (fval1 < 0) | (fval2 < 0)
	  Hnew = [];
	  fprintf('initialization error\n');
	  fprintf('error code : %d %d\n',exitflag1, exitflag2);

	  
	  return;
	end
	

	Hnew(i,:) = [fval1,fval2];
    end
end
% repair Hnew;
for i = 1:size(Hnew,1);
  if (Hnew(i,2) - Hnew(i,1)) < opts.minwidth;
    center = (Hnew(i,1)+Hnew(i,2))/2;
    Hnew(i,1) = max(1e-4,center - opts.minwidth/2);
    Hnew(i,2) = center+ opts.minwidth/2;
  end
  
end;
fprintf(']\n');

