function Hnew =  l1l1_triangle_initial_rectangle(opts,flag);
% see if we can fake the 3+
A = zeros(5*opts.n,3);
c = zeros(5*opts.n,1);
K.l=5*opts.n;


for i = 1:opts.n;
    srow = (i-1)*5;

    A(srow+1,:) = -squeeze(opts.delta*opts.Q(i,3,1:3)) + squeeze(opts.Q(i,1,1:3));
    c(srow+1)=squeeze(opts.delta*opts.Q(i,3,4) - squeeze(opts.Q(i,1,4)));

    % gamma *Q3+Q1  > 0
    A(srow+2,:) = -squeeze(opts.delta*opts.Q(i,3,1:3)) - squeeze(opts.Q(i,1,1:3));
    c(srow+2)=squeeze(opts.delta*opts.Q(i,3,4) + squeeze(opts.Q(i,1,4)));

    
    A(srow+3,:) = -squeeze(opts.delta*opts.Q(i,3,1:3)) + squeeze(opts.Q(i,2,1:3));
    c(srow+3)=squeeze(opts.delta*opts.Q(i,3,4) - squeeze(opts.Q(i,2,4)));

    A(srow+4,:) = -squeeze(opts.delta*opts.Q(i,3,1:3)) - squeeze(opts.Q(i,2,1:3));
    c(srow+4)=squeeze(opts.delta*opts.Q(i,3,4) + squeeze(opts.Q(i,2,4)));
    
    A(srow+5,:) = - squeeze(opts.Q(i,3,1:3));
    c(srow+5)= squeeze(opts.Q(i,3,4));
end


if nargin > 1;
    % just check feasability;
    i = 1;
    b = squeeze(opts.Q(i,3,1:3));
    %minimize
    [x1,fval1,exitflag1]=linprog(b,A,c,[],[],[],[],[],opts.lpoptions);
    if (exitflag1==1)
        Hnew=1;
    else
        Hnew = 0;
    end
    return;
end

Hnew = opts.ybounds;

fprintf('[');
for i = 1:opts.n;
 
    if (opts.branch_array(i));

        b = squeeze(opts.Q(i,3,1:3));
        %minimize
        [x1,fval1,exitflag1,output1,lambda1]=linprog(b,A,c,[],[],[],[],[],opts.lpoptions);
        [x2,fval2,exitflag2,output2,lambda2]=linprog(-b,A,c,[],[],[],[],[],opts.lpoptions);

        fval1= squeeze(opts.Q(i,3,1:3))'*x1+opts.Q(i,3,4);
        fval2= squeeze(opts.Q(i,3,1:3))'*x2+opts.Q(i,3,4);
	
	switch exitflag1;
	  
	 case 1;
	  fprintf('.');
	  fval1 = max(1e-10,fval1);
	 case -3;
	  fprintf('\');
	  fval1 = opts.ybounds(i,1);
	 otherwise
	  fval1 = -1;
	end
	
	switch exitflag2;
		  
	 case 1;
	  fprintf('.');
	  if (fval1 > opts.ybounds(i,2))
	    fval2 = fval1+opts.ybounds(i,2);
	  else
	    fval2 = min(max(1e-10,fval2),opts.ybounds(i,2));
	  end
	  
	 case -3;
	  fprintf('/');
	  fval2 = opts.ybounds(i,2);
	otherwise
	  fval2 = -1;
	end
	
	if (fval1 < 0) | (fval2 < 0)
	  Hnew = [];
	  fprintf('initialization error\n');
	  fprintf('error code : %d %d\n',exitflag1, exitflag2);
	  
	  return;
	end
	

	Hnew(i,:) = [fval1,fval2];
    end
end
% repair Hnew;
%vpa(Hnew,10)
for i = 1:size(Hnew,1);
  if (Hnew(i,2) - Hnew(i,1)) < opts.minwidth;
    center = (Hnew(i,1)+Hnew(i,2))/2;
    Hnew(i,1) = max(1e-4,center - opts.minwidth/2);
    Hnew(i,2) = center+ opts.minwidth/2;
  end
  
end;
fprintf(']\n');

