%function [U,itercount,eot,solution,opts]  = l1l1_triangulation(P,u,U0);
function [U,itercount,eot,solution,opts]  = l1l1_triangulation(u,P,epsilon,delta,maxiter);
	fprintf('\n\n******** Starting (L1,L1) Triangulation Algorithm ********\n\n');

  if nargin < 3;
    epsilon = 0.95;
  end
   
  if nargin < 4;
    delta = 15;
  end
  
  if nargin < 5;
    maxiter = 200;
  end
  
  U=[0,0,0]';
  itercount = -1;
  eot=-1;
  solution.feasible=0;
  
  
  opts = bbopts('l1l1_triangle',[],P,u');
  opts.epsilon = epsilon;
  opts.delta = delta;
  opts.maxiter = maxiter;
  
  tic;
  opts = l1l1_triangle_init(opts);
  if opts.feasible==0;
    fprintf('Initial region is infeasible\n');
  else
    [solution,itercount]=bandb(opts);
    eot=toc;
    
    if solution.feasible == 1;
      U = solution.point(1:3);
    end;
  end;

  U= U(:);
	fprintf('******** Ending (L1,L1) Triangulation Algorithm ********\n\n');
  