function [hh, lowerbound, objval] = boundresect(nbrpoints, numvar, inrect, xm, Xlist, m, n)

%keyboard;
b=sparse(zeros(numvar,1));
At_l=sparse(zeros(0,numvar));
c_l=sparse(zeros(0,1));
At=sparse(zeros(0,numvar));
c=sparse(zeros(0,1));
A_f = sparse(zeros(0,numvar));
c_f=sparse(zeros(0,1));

clear K;
K.f = 0;
K.l = 0;
K.q = [];

% Variable order : p_{11}, p_{12}, ...., p_{mn}, {t, s, sp, r, rp}_repeat

lower_vars = m*n+4:5:m*n+4+5*(nbrpoints-1);
numerator_vars = m*n+1:5:m*n+1+5*(nbrpoints-1);
denominator_vars = m*n+2:5:m*n+2+5*(nbrpoints-1);

i = 1;
shiftpos = m*n+(i-1)*5;

x = Xlist(:,i)';
u = xm(:,i);
c_f = 1;
A_f = [zeros(1,(m-1)*n), x, zeros(1,numvar-m*n)];
K.f = 1;

b(shiftpos+4) = -1;

Atmp = sparse(zeros(0,numvar)); ctmp = sparse(zeros(0,1));
Atmp(1,m*n+2) = 1; ctmp(1,1) = 1;
Atmp(2,m*n+3) = 1; ctmp(2,1) = 1;
Atmp(3,m*n+1) = 1; Atmp(3,m*n+4) = -1; ctmp(3,1) = 0;
Atmp(4,m*n+5) = 1; ctmp(4,1) = 1;
A_f = [A_f; Atmp]; c_f = [c_f; ctmp];
K.f = K.f + 4;

Atmp = sparse(zeros(0,numvar)); ctmp = sparse(zeros(0,1));
for ii = 2:nbrpoints
    x = Xlist(:,ii)';
    shiftpos = m*n+(ii-1)*5;
    Atmp(ii-1,shiftpos+2) = 1;
    Atmp(ii-1,(m-1)*n+1:m*n) = -x;
    ctmp(ii-1,1) = 0;
end
A_f = [A_f; Atmp]; c_f = [c_f; ctmp];
K.f = K.f + nbrpoints - 1;

u = xm(:,1);
shiftpos = m*n;
x = Xlist(:,1)';
ctmp = sparse(m,1);  Atmp = sparse(m, numvar);
Atmp(1,shiftpos+1) = -1;
for j = 1:m-1
    Atmp(j+1,(j-1)*n+1:j*n) = x;
    ctmp(j+1,1) = u(j);
end

c = [c; ctmp];
At = [At; Atmp];
K.q = [K.q, m];



for i = 2:nbrpoints
    
    % Borders for the rectangle being considered 
    tL = inrect.tllist(i);  tU = inrect.tulist(i);
    sL = inrect.sllist(i);  sU = inrect.sulist(i);
    
    shiftpos = m*n+(i-1)*5;
    
    b(shiftpos+4) = -1;
    
    x = Xlist(:,i)';
    u = xm(:,i);
    
    %if i == 1
    %  ctmp = [];  Atmp = sparse(1,numvar);
    %  ctmp = 1;
    %  Atmp = [zeros(1,(m-1)*n), x, zeros(1,numvar-m*n)];
    %  c_f(1,1) = 1;
    %  A_f(1,:) = [zeros(1,(m-1)*n), x, zeros(1,numvar-m*n)];
    %  K.f = K.f+1;
    %end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% Cone constraints
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %% Eqn 15

    ctmp = sparse(m,1);  Atmp = sparse(m, numvar);
    Atmp(1,shiftpos+1) = -1;
    for j = 1:m-1
        Atmp(j+1,(j-1)*n+1:j*n) = x;
        Atmp(j+1,(m-1)*n+1:m*n) = -u(j)*x;
    end
            
    c = [c; ctmp];
    At = [At; Atmp];
    K.q = [K.q, m];

    %% Eqn 1

    ctmp = []; Atmp = [];
    ctmp = sparse(3,1);  Atmp = sparse(3,numvar);

    ctmp(2,1) = 2*sqrt(tL)*tU/(tU-tL);
    
    Atmp(1,shiftpos+3) = -1;
    Atmp(1,shiftpos+5) = -1;
    Atmp(2,shiftpos+1) = 2*sqrt(tL)/(tU-tL);
    Atmp(3, shiftpos+3) = 1;
    Atmp(3,shiftpos+5) = -1;
    
    c = [c; ctmp];
    At = [At; Atmp];
    K.q = [K.q, 3];

    %% Eqn 2

    ctmp = []; Atmp = [];
    ctmp = sparse(3,1);  Atmp = sparse(3,numvar);

    ctmp(2,1) = 2*sqrt(tU)*tL/(tU-tL);
    
    Atmp(1,shiftpos+2) = -1;
    Atmp(1,shiftpos+3) = 1;
    Atmp(1,shiftpos+4) = -1;
    Atmp(1,shiftpos+5) = 1;
    Atmp(2,shiftpos+1) = 2*sqrt(tU)/(tU-tL);
    Atmp(3,shiftpos+2) = 1;
    Atmp(3,shiftpos+3) = -1;
    Atmp(3,shiftpos+4) = -1;
    Atmp(3,shiftpos+5) = 1;
    
    c = [c; ctmp];
    At = [At; Atmp];
    K.q = [K.q, 3];
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Linear constraints
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    ctmp = []; Atmp = [];
    ctmp = sparse(12,1);  Atmp = sparse(12,numvar);
    
    ctmp(1,1) = -sL*tU;
    ctmp(2,1) = -sU*tL;
    ctmp(3,1) = sU*tU;
    ctmp(4,1) = sL*tL;
    ctmp(9,1) = -tL;
    ctmp(10,1) = tU;
    ctmp(11,1) = -sL;
    ctmp(12,1) = sU;
%    ctmp(13,1) = x(n);

    Atmp(1,shiftpos+1) = -sL;
    Atmp(1,shiftpos+3) = -(tU-tL);
    Atmp(2,shiftpos+1) = -sU;
    Atmp(2,shiftpos+2) = tU-tL;
    Atmp(2,shiftpos+3) = -(tU-tL);
    Atmp(3,shiftpos+1) = sU;
    Atmp(3,shiftpos+3) = tU-tL;
    Atmp(4,shiftpos+1) = sL;
    Atmp(4,shiftpos+2) = -(tU-tL);
    Atmp(4,shiftpos+3) = tU-tL;
    Atmp(5,shiftpos+5) = -1;
    Atmp(6,shiftpos+4) = -1;
    Atmp(6,shiftpos+5) = 1;
    Atmp(7,shiftpos+2) = -1;
    Atmp(7,shiftpos+3) = 1;
    Atmp(8,shiftpos+3) = -1;
    Atmp(9,shiftpos+1) = -1;
    Atmp(10,shiftpos+1) = 1;
    Atmp(11,shiftpos+2) = -1;
    Atmp(12,shiftpos+2) = 1;
%    Atmp(13,shiftpos+2) = 1;
%    Atmp(13,(m-1)*n+1:m*n) = -x;
    
    c_l = [c_l; ctmp];
    At_l = [At_l; Atmp];
    K.l = K.l+12;

end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SEDUMI

pars=[];
pars.fid=0;
pars.eps = 0;
%keyboard;
[x,y,info]=sedumi([A_f;At_l;At],b,[c_f(:);c_l;c],K,pars);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if info.dinf==1 || info.numerr == 2 % no feasible solution
    fprintf('\n');
    disp('Infeasible. Setting lower bound to infinity.');
    lowerbound=Inf;
    objval = Inf;
    hh.y = zeros(numvar,1);
else
%   disp('Feasible solution found.');
    lowerbound = sum(y(lower_vars));
    objval = sum(y(numerator_vars) ./ y(denominator_vars));
    hh.y=y;
end
%inrect





