function [H, feas_status] = initial_bound_triang(xm, P, nbrimages, nbrpoints, beta, maxdepth, flag);

%keyboard;
feas_status = 1;
n=nbrimages;
Al = []; cl = [];
A = zeros(n*3,3);
c = zeros(n*3,1);
b = zeros(3,1);

clear K;
K.q = ones(n,1)*3;
K.l = 4*n+n;

umax = max(xm(1,:));
umin = min(xm(1,:));
vmax = max(xm(2,:));
vmin = min(xm(2,:));

uminb = umin-(umax-umin)/2;
umaxb = umax+(umax-umin)/2;
vminb = vmin-(vmax-vmin)/2;
vmaxb = vmax+(vmax-vmin)/2;

for i =1:n;
    C = P{i};
    %    C = C/C(end);
    u = xm(1,i);v = xm(2,i);
    Q1 = C(3,:)*u - C(1,:);
    Q2 = C(3,:)*v - C(2,:);
    Q3 = C(3,:);

    Al(4*(i-1)+1,1:3) = C(1,1:3)-umaxb*C(3,1:3);
    cl(4*(i-1)+1,1) = C(3,4)*umaxb-C(1,4);
    Al(4*(i-1)+2,1:3) = C(2,1:3)-vmaxb*C(3,1:3);
    cl(4*(i-1)+2,1) = C(3,4)*vmaxb-C(2,4);

    Al(4*(i-1)+3,1:3) = uminb*C(3,1:3)-C(1,1:3);
    cl(4*(i-1)+3,1) = C(1,4) - uminb*C(3,4);
    Al(4*(i-1)+4,1:3) = vminb*C(3,1:3)-C(2,1:3);
    cl(4*(i-1)+4,1) = C(2,4) - vminb*C(3,4);

    Atmp(i,1:3) = C(3,1:3);
    ctmp(i,1) = maxdepth - C(3,4);

    A(3*(i-1)+1:3*i,:) = [-beta*Q3(1,1:3); -Q1(1,1:3); -Q2(1,1:3)];
    c(3*(i-1)+1:3*i) = [beta*Q3(4); Q1(4); Q2(4)];
end

A = [Al;Atmp;A];  c = [cl;ctmp;c];

H = zeros(n,2);

if flag == 1
    pars1.fid = 0;
    pars1.eps = 0;
    [x1,y1,info1] = sedumi(A,0,c,K,pars1);
    if info1.dinf == 1 || info1.numerr == 2
        feas_status = 0;
    end
    H = zeros(n,2);
    return;
end


for i = 1:n;
    C = P{i};
    %    C = C/C(end);
    b = C(3,1:3);
    pars1.fid = 0;
    pars1.eps = 0;
    if flag == 1
        b = zeros(size(b));
    end
    [x1,y1,info1] = sedumi(A,-b,c,K,pars1); % -b
    if info1.dinf == 1 || info1.numerr == 2
        feas_status = 0;
        H = zeros(n,2);
        return;
    end
    H(i,1) = b*y1+C(3,4);
    pars2.fid = 0;
    pars2.eps = 0;
    [x2,y2,info2] = sedumi(A,b,c,K,pars2); % b
    if info2.dinf == 1 || info2.numerr == 2
        feas_status = 0;
        H = zeros(n,2);
        return;
    end
    H(i,2) = b*y2+C(3,4);
end

